// Copyright (C)  2016 - INRIA - Serge Steer
//
// This file is licensed under the  the CeCILL v.2.1.
function [sciblk, s1, s2]=DiffInt(job, sciblk, e1)
  s1 = []; s2 = [];
  select job
  case "set" then
    if size(sciblk.graphics.exprs,'*')==2 then sciblk.graphics.exprs=["-1";sciblk.graphics.exprs];end
    while %t 
      [ok, statetype, x0, xd0, exprs] = scicos_getvalue(_("Derivative block parameters"),...
                                      [_("State type 1:differential,0:algebraic");
                                       _("Initial state value");
                                       _("Initial derivative value")],...
                                      list("vec",1,"vec",1,"vec",1), sciblk.graphics.exprs);
      if ~ok then return,end
      if or(statetype==[1 0]) then break,end
       messagebox(_("The state type value must be equal to 1 or 0"),"modal");
    end
    sciblk.model.state = [x0; xd0];
    sciblk.model.ipar  = statetype;
    sciblk.graphics.exprs = exprs;
  case "define" then
    statetype = 0;
    x0 = 0;xd0 = 0;
    model = scicos_model()
    model.sim = list("DiffSim",10004)
    model.intyp = 1;
    model.in = 1;
    model.in2 = 1;
    model.outtyp = 1;
    model.out = 1;
    model.out2 = 1;
    model.ipar = statetype;
    model.state = [x0;xd0];
    model.dep_ut = [%f %t];
    exprs = [sci2exp(statetype);sci2exp(x0);sci2exp(xd0)];
    sciblk = standard_define([2 2],model,exprs);
    style_properties=["blockWithLabel";
                      "verticalLabelPosition=middle"
                      "verticalAlign=middle";
                      "displayedLabel=Diff"],
    sciblk.graphics.style = strcat(style_properties,";")
  end
endfunction
