// Copyright (C)  2016 - INRIA - Serge Steer
//
// This file is licensed under the  the CeCILL v.2.1.
function [sciblk, s1, s2] = IntegralInt(job, sciblk,e1)
  s1= []; s2 = [];
  select job
  case "set" then
    exprs = sciblk.graphics.exprs;
    [ok,x0,reinit,exprs]=scicos_getvalue(_("Integral block parameters"),...
                                         [_("Initial Condition");
                    _("With re-intialization (1:yes, 0:no)")],...
                                         list("vec",-1,"vec",1),exprs)
    if ~ok then return;end
    n = size(x0,'*');
    out = [n, 1];
    outype = 1;
    evtout = []; //aucun port de sortie d'activation
    if reinit~= 0 then 
      //deux entrées regulière de dimension n x 1
      intype = [1, 1];
      in = [n, 1; n, 1];
      //un port d'entrée d'activation
      evtin = 1; 
      reinit = 1;
    else
      //une entrée regulière de dimension n x 1
      intype = 1;
      in = [n, 1];
      //aucun port d'entrée d'activation 
      evtin = [];
    end
    [model,graphics] = set_io(sciblk.model, sciblk.graphics,...
                                 list(in, intype), list(out, outype),...
                                 evtin, evtout)
    model.ipar = reinit;
    model.state = x0(:);
    sciblk.model = model;
    graphics.exprs = exprs;
    sciblk.graphics = graphics;
  case "define" then
    //initialisation mono dim sans reinit
    x0=0;
    reinit=0;
    model = scicos_model();
    model.state = x0;
    model.sim = list("IntegralSim",4)
    model.intyp = 1;
    model.outtyp = 1;
    model.in = 1;
    model.in2 = 1;
    model.out = 1;
    model.out2 = 1;
    model.dep_ut = [%f %t];
    exprs = [sci2exp(x0);sci2exp(reinit)];
    sciblk = standard_define([2 2],model,exprs);
    style_properties = ["blockWithLabel"
                        "verticalLabelPosition=middle"
                        "verticalAlign=middle"
                        "displayedLabel=$\int$"];
    sciblk.graphics.style = strcat(style_properties,";");
  end
endfunction
