// Copyright (C)  2016 - INRIA - Serge Steer
//
// This file is licensed under the  the CeCILL v.2.1.
function [sciblk,s1,s2]=ThyristorIns(job,sciblk,e1)
    s1=[];s2=[];
    select job
     case "set" then
      exprs=sciblk.graphics.exprs;
      while %t do
          [ok,VDRM,VRRM,IDRM,VTM,IH,ITM,VGT,IGT,TON,TOFF,Vt,Nbv,exprs]=...
              getvalue(_("Instrumented Thyristor"),...
                       [__("VDRM [V] : Forward breakthrough voltage (>= 0)");...
                        __("VRRM [V] : Reverse breakthrough voltage (>= 0)");...
                        __("IDRM [A] : Saturation current");...
                        __("VTM [V] : Conducting voltage");...
                        __("IH [A] : Holding current");...
                        __("ITM [A] : Conducting current");...
                        __("VGT [V] : Gate trigger voltage");...
                        __("IGT [A] : Gate trigger current");...
                        __("TON [s] : Switch on time");...
                        __("TOFF [s] : Switch off time");...
                        __("Vt [V] : Voltage equivalent of temperature (kT/qn)");...
                        __("Nbv [-] : Reverse Breakthrough emission coefficient")],...
                       list("vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1),exprs);
          if ~ok then break, end
          listpar=list(VDRM,VRRM,IDRM,VTM,IH,ITM,VGT,IGT,TON,TOFF,Vt,Nbv);
          sciblk.model.equations.parameters(2)=listpar;
          sciblk.graphics.exprs=exprs;
          break
      end
     case "define" then
      //valeur initiales des paramètres
      VDRM=100;  VRRM=100; IDRM=0.1; VTM=1.7;
      IH=0.006; ITM=25; VGT=0.7; IGT=0.005;
      TON=0.000001; TOFF=0.000015;
      Vt=0.04; Nbv=0.74;
      listpar=list(VDRM,VRRM,IDRM,VTM,IH,ITM,VGT,IGT,TON,TOFF,Vt,Nbv);
      namespar=["VDRM","VRRM","IDRM","VTM","IH","ITM","VGT","IGT","TON","TOFF","Vt","Nbv"];
      typepar=[0,0,0,0,0,0,0,0,0,0,0,0];


      model=scicos_model();
      model.sim=""; //non utilisé dans le cas des blocs Modelica
      model.blocktype="c";
      model.dep_ut=[%t %f];
      mo=modelica();
      mo.model="ThyristorIns";
      mo.inputs=["Anode","Gate"]; 
      mo.outputs=["Cathode","Tension","Courant","Puissance"];
      mo.parameters=list(namespar,listpar,typepar);
      model.equations=mo;
      model.in=ones(mo.inputs)';
      model.out=ones(mo.outputs)';
      exprs=[sci2exp(VDRM);sci2exp(VRRM);sci2exp(IDRM);sci2exp(VTM);
                  sci2exp(IH);sci2exp(ITM);sci2exp(VGT);sci2exp(IGT);
                  sci2exp(TON);sci2exp(TOFF);sci2exp(Vt);sci2exp(Nbv)];
      sciblk=standard_define([2 2],model,exprs);
      sciblk.graphics.in_implicit=["I","I"];
      sciblk.graphics.out_implicit=["I","I","I","I"]; 

      sciblk.graphics.in_style=[ElecInputStyle(), ElecInputStyle() ];
      sciblk.graphics.out_style=[ElecOutputStyle(),RealOutputStyle(), ...
                    RealOutputStyle(),RealOutputStyle()];

      sciblk.graphics.in_label=["$A_n$","$G$"];
      sciblk.graphics.out_label=["$C_a$","$v_{AC}$","$i_c$","$p_{AC}$"]
    end
endfunction
