/* Copyright (C)  2016 - INRIA - Serge Steer
   This file is licensed under the  the CeCILL v.2.1.*/
#include <math.h>
#include <stdlib.h>
#include "scicos_block4.h"

void  AbsSim(scicos_block *Cblk, int flag)
{
  double *u  = GetRealInPortPtrs(Cblk,1); 
  double *y = GetRealOutPortPtrs(Cblk,1);
  int     n = GetInPortRows(Cblk,1); 
  int *mode = GetModePtrs(Cblk);
  int i = 0;

  sciprint("flag=%d,phase=%d, u=%f\n",flag,get_phase_simulation(),u[0]);

  if (flag == OutputUpdate || flag == ReInitialization){
    if (get_phase_simulation() == 1) 
      for(i = 0; i < n; i++) y[i] = fabs(u[i]);
    else 
      for(i = 0; i < n; i++) y[i] = ((mode[i] == 1) ? (u[i]) : (-u[i]));
  }
  else if (flag == ZeroCrossing) {
    double *g = GetGPtrs(Cblk);
    for(i = 0; i < n; ++i) {
      g[i] = u[i];
      if (get_phase_simulation() == 1) 
        mode[i] = (u[i] < 0.0) ? 2:1;
    }
  }
}

