/* Copyright (C)  2016 - INRIA - Serge Steer
   This file is licensed under the  the CeCILL v.2.1.*/
#include "math.h"
#include <MALLOC.h>
#include "scicos_block4.h"
#include "scicos.h"
void LocalMaxSim(scicos_block *Cblk, scicos_flag flag)
{
  int i = 0;
  double *work = NULL;
  switch(flag) {
  case Initialization:
    if ((GetWorkPtrs(Cblk) = (double *)MALLOC(6*sizeof(double)))== NULL ) {
      Coserror("%s: Memory allocation problem\n", "LocalMax");
      return;
    }
    work = (double *)GetWorkPtrs(Cblk);
    for (i=0; i<6; i++) work[i] = 0.0;
    break;
  case OutputUpdate:
  case ReInitialization:
    work = (double *)GetWorkPtrs(Cblk);
    *GetRealOutPortPtrs(Cblk,1) = work[3];
    *GetRealOutPortPtrs(Cblk,2) = work[5];
    break;
  case StateUpdate:
    work = (double *)GetWorkPtrs(Cblk);
    work[0] = work[1];
    work[1] = work[2];
    work[2] = *GetRealInPortPtrs(Cblk,1);
    if (work[1] > work[0] && work[1] > work[2]){
      work[3] = work[1]; /*max value stored*/
      work[5] = work[4]; /*occurrence date stored*/
    }
    work[4] = get_scicos_time();
    break;
  case OutputEventTiming:
    work =  (double *)GetWorkPtrs(Cblk);
    if (work[1] > work[0] && work[1] > work[2]) {
      *GetNevOutPtrs(Cblk) =  0; 
    }
    else 
      *GetNevOutPtrs(Cblk) =   - 1.0;
    break;
  case  Ending:
    FREE(GetWorkPtrs(Cblk));
  }
}

