//Import de la structure de données scs_m associée au schéma
importXcosDiagram("scilab-xcos-Amortisseur.zcos");
//Acquisition des paramètres définis dans le contexte
execstr(scs_m.props.context)
//Définition des valeurs d'éssai pour la raideur et l'amortissement
K=(0.6:0.05:1.5)*1e4;nK=length(K)
C=1000:50:2500;nC=length(C);
//initialisation des tableaux résultats
Rp=zeros(nK,nC);
Rt=zeros(nK,nC);
Info=list();
for i=1:nK
  //Mise a jour des variables de contexte k et zce 
  Context.k=K(i);
  Context.zce=l-m*g/K(i);
  for j=1:nC
    //Mise a jour de la variable de contexte c
    Context.c=C(j);
    //Lancement de la simulation
    Info=scicos_simulate(scs_m,Info,Context,"nw");
    //Récuperation et rangement des résultats
    Rp(i,j)=Max.values;//Valeur du premier dépassement
    Rt(i,j)=T.values-2;
  end
end

R=100*Rp/step-100;

f=scf(0);f.color_map=jetcolormap(128);clf;

subplot(121)
ax=gca();ax.margins(1)=0.2;

colorbar(0,5,[1 128],"%.2g %%")
grayplot(K,C,R)
xlabel("Raideur");ylabel("Amortissement")
title("Dépassement")

subplot(122)
ax=gca();ax.margins(1)=0.2;
colorbar(min(Rt),max(Rt),[1 128],"%.2g s")
grayplot(K,C,Rt)
xlabel("Raideur");ylabel("Amortissement")
title("Temps de ralliement à 2.5%")

