//Import de la structure de données scs_m associée au schéma
importXcosDiagram("scilab-xcos-Amortisseur2.zcos");
//Acquisition des paramètres définis dans le contexte
execstr(scs_m.props.context)
//Définition des valeurs d'éssai pour la raideur et l'amortissement
KC=[8000 10000 10000
     800 14000   800];
R=[];
Info=list();
L='Profil de la route';
for i=1:3
  //Mise a jour des variables de contexte k et c
  Context.k=KC(1,i);Context.c=KC(2,i);
  //Simulation
  Info=scicos_simulate(scs_m,Info,Context);
  //lecture et stockage du résultat
  fd=mopen("resultat.dat","rb");r=mget(1000,'d',fd);mclose(fd);
  R=[R;r];
  L=[L;msprintf("Caisse: k=%d, c=%d\n",KC(1,i),KC(2,i))];
end

//Affichage 
//Lecture du profil de la route
fd=mopen("route.dat","rb");
tp=matrix(mget(2000,'d',fd),2,-1);
mclose(fd)
R=[tp(2,2:$);R];
clf;
subplot(211) //Evolution temporelle
plot(tp(1,2:$),R')
xlabel('temps')
ylabel("Cote (m)")

subplot(212) //Analyse fréquentielle
N=size(R,2);
dt=tp(1,2)-tp(1,1); //pas d'échantillonnage en temps
Y=[];for k=1:4,Y=[Y;abs(fft(R(k,:)))];end
plot((0:100)/(N*dt),20*log10(Y(:,1:101))')
xlabel("fréquence")
ylabel("Module (dB)")
legend(L);

